%define anolis_release 1
%global pkg intel_dlb2
%define pkg_version 8.2.0
%global debug_package %{nil}
%global kernel 5.10.134-16.an8

Name:           kmod-%{pkg}
Version:        %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:        %{pkg_version}~%{anolis_release}%{?dist}
Summary:        Intel DLB2 Driver

License:        GPLv2.0+
URL:            https://www.intel.com/content/www/us/en/download/686372/773770/intel-dynamic-load-balancer.html
Source0:        https://downloadmirror.intel.com/773770/%{name}-%{pkg_version}.tar.gz
Source1:        kmod-intel_dlb2-8.2.0.tar.gz

ExclusiveArch:  x86_64

Requires:            kernel >= %{kernel}
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

BuildRequires:  gcc
BuildRequires:  make
BuildRequires:  kernel-headers = %{kernel}
BuildRequires:  kernel-devel = %{kernel}
Provides:       kmod-intel_dlb2 = %{release}
Obsoletes:      kmod-intel_dlb2 < %{release}
Obsoletes:      kmod-intel_dlb2 < %{pkg_version}-3%{?dist}

%description
Implementation of the dlb2 driver

%prep
%setup -q -n %{name}-%{pkg_version}

%build
%{__make} -C /usr/src/kernels/%{kernel}.%{_arch} %{?_smp_mflags} M=$PWD modules

%install
mkdir -p %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra
%{__install} -D -t %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra dlb2.ko

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kernel}.%{_arch}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a %{kernel}.%{_arch}
dracut -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}
if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kernel}.%{_arch}/extra/dlb2.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

%preun
# 这里换成自己的ko路径，目的是将ko路径都保存到一个临时文件里然后在%postun阶段从weak-modules里注销。
echo "/lib/modules/%{kernel}.%{_arch}/extra/dlb2.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a %{kernel}.%{_arch}
dracut -f /boot/initramfs-%{kernel}.%{_arch}.img %{kernel}.%{_arch}

# 将模块的ko从weak-modules里注销，这里的rpm-%{pkg}-modules.list是在%preun阶段生成的。
if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
%defattr(644,root,root,755)
%license license
/lib/modules/%{kernel}.%{_arch}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Thu Nov 9 2023 Xingrui Yi <yixingrui@linux.alibaba.com> - 8.2.0-1
- Change spec to OOT weak module
